#include "assyms.h"

.text
	.even
.globl _savectx
_savectx:
	/* first argument is the task_struct */
	movel	sp@(4),a0

	/* save status register */
	movew	sr,a0@(TS_SR)

	/* save current alternate address space */
	movec	sfc,d0
	movel	d0,a0@(TS_FS)

	/* save user stack pointer */
	movel	usp,a1
	movel	a1,a0@(TS_USP)

	/* save non-scratch registers */
	movml	d2-d7/a2-a7,a0@(TS_REGS)

#if 0
	/* save floating point state (if necesarry) */
	if (last_task_used_math == current)
		__asm__("clts ; fnsave %0 ; frstor %0"::"m" (p->tss.i387));
#endif

	/* second argument is altreturn */
	movel	sp@(8),d0
	beq	Lnotalt

	/* copy return address from this stack to the new one */
	movel	sp,a1
	subl	#KSTACK_ADDR,a1
	addl	a0@(TS_KSTACKP),a1
	movel	sp@,a1@
Lnotalt:
	moveq	#0,d0
	rts

.globl _resume
	.even
_resume:
	/* current */
	movel	_current,a0

	/* save sr */
	movew	sr,a0@(TS_SR)

	/* disable interrupts */
	oriw	#0x0700,sr

	/* save fs (sfc,dfc) (may be pointing to kernel memory) */
	movec	sfc,d0
	movel	d0,a0@(TS_FS)

	/* save usp */
	movel	usp,a1
	movel	a1,a0@(TS_USP)

	/* save non-scratch registers */
	moveml	d2-d7/a2-a7,a0@(TS_REGS)

#if 0
	/* save floating point state (if necesarry) */
	if (last_task_used_math == current)
		__asm__("clts ; fnsave %0 ; frstor %0"::"m" (p->tss.i387));
#endif

	/* switch current task */
	movel	sp@(4),a0
	movel	a0,_current

	/*
	 * switch address space
	 */


	/* first, the kernel stack */
	movel	a0@(TS_PMAP+PMAP_KSTACKP),d0
	oril	#PAGE_PRESENT,d0
	movel	_kstack_descp,a1
	movel	d0,a1@

	/* switch the root pointer */
	pmove	a0@(TS_PMAP+PMAP_CRP),crp

	/* flush address translation cache (probably not needed */
	pflusha

	/* flush caches */
	movec	cacr,d0
	oril	#FLUSH_I_AND_D,d0
	movec	d0,cacr

#if 0
	/* restore floating point state (if necesarry) */
	if (last_task_used_math == current)
		__asm__("clts ; fnsave %0 ; frstor %0"::"m" (p->tss.i387));
#endif

	/* restore non-scratch registers */
	moveml	a0@(TS_REGS),d2-d7/a2-a7

	/* restore usp */
	movel	a0@(TS_USP),a1
	movel	a1,usp

	/* restore fs (sfc,dfc) */
	movel	a0@(TS_FS),d0
	movec	d0,sfc
	movec	d0,dfc

	/* restore status register */
	movew	a0@(TS_SR),sr

	/* return 1 for newly forked task */
	moveq	#1,d0
	rts
